<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Macro Script for Visualization</title>
    <style>
      body {
        margin: 0;
        overflow: hidden;
      }

      iframe {
        border: 0;
        position: absolute;
        left: 0px;
        width: 100%;
        top: 0px;
        height: 100%;
      }
    </style>
    <script>
      window.onload = () => {
        dom.id = "child";
        dom.src = "./inner.html" + window.location.search;
        document.body.appendChild(dom);
      };
      const dom = document.createElement("iframe");

      window.addEventListener("message", m => console.log(m), false);
    </script>
    <script src="https://cdn.jsdelivr.net/npm/sockjs-client@1/dist/sockjs.min.js"></script>
    <script src="https://our-sci.gitlab.io/npm-libs/v1/wrapper-compiled.js"></script>
    <script>
      let retries = 0;
      let sock = null;

      const socket = function initSocket(url, handlers) {
        sock = new SockJS(url);

        sock.onopen = function onopen() {
          retries = 0;
        };

        sock.onclose = function onclose() {
          if (retries === 0) {
            handlers.close();
          }

          // Try to reconnect.
          sock = null;

          // After 10 retries stop trying, to prevent logspam.
          if (retries <= 10) {
            // Exponentially increase timeout to reconnect.
            // Respectfully copied from the package `got`.
            // eslint-disable-next-line no-mixed-operators, no-restricted-properties
            const retryInMs = 1000 * Math.pow(2, retries) + Math.random() * 100;
            retries += 1;

            setTimeout(() => {
              socket(url, handlers);
            }, retryInMs);
          }
        };

        sock.onmessage = function onmessage(e) {
          // This assumes that all data sent via the websocket is JSON.
          const msg = JSON.parse(e.data);
          if (handlers[msg.type]) {
            handlers[msg.type](msg.data);
          }
        };
      };

      let oldHash = null;
      let newhash = null;
      socket("http://localhost:7654/sockjs-node/", {
        hot() {
          console.log("hot");
        },
        invalid() {
          console.log("invalid");
        },
        hash(hash) {
          console.log("hash: "+hash);
          newhash = hash;
          if(!oldHash){
            oldHash = hash;
          }
        },
        "still-ok": function stillOk() {
          console.log('stillOk');
        },
        ok() {
          console.log('ok');
          if(newhash){
            if(newhash !== oldHash){
              window.location.href = window.location.href;
              oldHash = newhash;
            }
          }          
        },
        warnings() {
          console.log('warnings');

        },
        errors: function msgErrors(errors) {
          console.log('errors');
          console.log(errors);
        },
        close() {
          console.log('close');
        }
      });
    </script>
  </head>

  <body></body>
</html>
